/* //////////////////////////////////////////////////////////////////////////////////////
Suite logicielle Pikasuite
Auteur: Julien PIASECKI
Mail : pikachu_42@hotmail.com ou julien.piasecki@hotmail.fr
Ensemble de fonctions de gestion du module GLCD

///////////////////////////////////////////////////////////////////////////////////////*/

#include <htc.h>
#include <stdio.h>
#include "delay.h"
#include "io_config.h"
#include "variables_globales.h"
#include "fonctions_globales.h"


int ADC_Read(int chanel)
{
    // Conversion ADC sur le bon chanel
      ADCON0=0x00;
      ADCON0 = (chanel<<2);       	 // Select ADC Channel
      ADON=1;                	 // Switch on the ADC module
      ADCON0 = ADCON0 | 0x02;    // Start conversion
      while(GO/DONE);            // Wait forthe conversion to finish
      ADON=0;            		 // Switch off ADC
	  return ADRES;
}

//////////////////////
int GetX_panel(void) 
{
  int adc_rd = 0;
  float iAmpl_x = 0.0;			   //  Valeur tampon pendant la conversion	
  driveA = 1;               	   //' DRIVEA = 1 (LEFT drive on, RIGHT drive on, TOP drive off)
  driveB = 0;               	   //' DRIVEB = 0 (BOTTOM drive off)
  DelayUs(50);	
  adc_rd = ADC_Read(0);		       //' READ-X (BOTTOM)

  // Conversion en valeurs entre 0 et 127 pour situer sur la grille des X
  iAmpl_x = X_TP_MAX_CALIB - X_TP_MIN_CALIB;
  adc_rd = adc_rd - X_TP_MIN_CALIB;			// recalage
  iAmpl_x = (adc_rd /iAmpl_x) * 127.0;		// recalage entre 0 et 127

  return iAmpl_x;	
}

/////////////////////
int GetY_panel(void) 
{
  int adc_rd = 0;
  float iAmpl_y = 0.0;			   //  Valeur tampon pendant la conversion
  driveA = 0;                      //' DRIVEA = 0 
  driveB = 1;                      //' DRIVEB = 1 
  DelayUs(50);	
  adc_rd = ADC_Read(1);		       //' READ-Y (BOTTOM)

  // Conversion en valeurs entre 0 et 127 pour situer sur la grille des X
  iAmpl_y = Y_TP_MAX_CALIB - Y_TP_MIN_CALIB;
  adc_rd = adc_rd - Y_TP_MIN_CALIB;					// recalage
  iAmpl_y = 63.0 -  ((adc_rd /iAmpl_y) * 63.0);		// recalage entre 0 et 127

  return  iAmpl_y;
}


/////////////////////////
// renvoie 1 ou 0
////////////////////////:
int detect_touch(void)
{
	int x,y = 0;				   // valeurs de lecture sur le touch panel
	x = GetX_panel();
	y = GetY_panel();

	if ( y > 63)				   // valeur par dfaut 
		return 0;

	if ( y < 63)
		return 1;
}
