/* //////////////////////////////////////////////////////////////////////////////////////
Suite logicielle Pikasuite
Auteur: Julien PIASECKI
Mail : pikachu_42@hotmail.com ou julien.piasecki@hotmail.fr
Ensemble de fonctions de gestion de l'oscilloscope

///////////////////////////////////////////////////////////////////////////////////////*/

#include "variables_globales.h"
#include "fonctions_globales.h"
#include "glcd.h"
#include "delay.h"
#include "io_config.h"
#include "adc_lib.h"


void oscilloscope (void)
{
	int adc_rd = 0;					// valeur de l'ADC pour l'oscilloscope		
    compteur_1_ms = 0;
	compteur_s = 0;
	iTemporal_axis = 0;				// on rinitialise les abscisses
	compteur_oscillo_1_ms = 0;
	
	do
	{
		// On teste si l'utilisateur n'a pas appuy sur la croix en haut  droite pour sortir
	    if (detect_touch()==1)														// on n'analyse l'appui que si dtect
        {
			// On lit les valeurs x et y
			x_coord = GetX_panel();
			y_coord = GetY_panel();

			// Si on a appuy sur la croix on revient au menu principal
			if ((x_coord > 110) && (y_coord < 15))
			{
				GLCD_PUTSTRING("X", 122, 0, 1);				// on inverse la couleur
				DelayMs(100);
				iApplication = 0;
				gotoMenuInitial();							// on raffiche le menu de dpart
				return;
			}	
					
		}
		
		// on lit l'ADC qui correspond  l'entre mesure au moment voulu
		if (iMaj_oscillo_to_do == 1)
		{
			iMaj_oscillo_to_do = 0;												// RAZ pour la prochaine acquisition
			compteur_oscillo_1_ms = 0;
			adc_rd = ADC_Read(2);        
		
			//Mise  jour de l'abscisse o dessiner le nouveau point
			if (iTemporal_axis>127)
			{
			   iTemporal_axis=0;
	
			   // On efface l'cran
		       GLCD_CLR(); 
			   GLCD_RECT(0, 63, 0, 127);                                     	 // Cadre extrieur
			   GLCD_PUTSTRING("X", 122, 0, 0);								 	 // croix en haut  gauche
			} else iTemporal_axis++;
			 
			 // On mets  l'chelle des amplitude le nouveau point
			 iAmplitude_axis = 64.0 -  (adc_rd/1024.0)*64.0;
			 
			 // On dessine le nouveau point aux bonnes abscisses amplitudes
		 	GLCD_Draw_Point(iTemporal_axis, iAmplitude_axis ,1);
		}



     }while (1);
}
