/* //////////////////////////////////////////////////////////////////////////////////////
Suite logicielle Pikasuite
Auteur: Julien PIASECKI
Mail : pikachu_42@hotmail.com ou julien.piasecki@hotmail.fr
Ensemble de fonctions de gestion du test du servomoteur

///////////////////////////////////////////////////////////////////////////////////////*/
#include <htc.h>
#include "variables_globales.h"
#include "fonctions_globales.h"
#include "glcd.h"
#include "delay.h"
#include "io_config.h"
#include "adc_lib.h"


void test_servomoteur (void)
{
	int adc_rd = 0;					// valeur de l'ADC pour la lecture du potentiomtre
	float x_cursor = 0.0;			// position du curseur du timer sur l'axe des x		
	compteur_oscillo_1_ms = 0;
	float pwm_old = 0.0;			// valeur prcdente
	
	do
	{
		// On teste si l'utilisateur n'a pas appuy sur la croix en haut  droite pour sortir
	    if (detect_touch()==1)														// on n'analyse l'appui que si dtect
        {
			// On lit les valeurs x et y
			x_coord = GetX_panel();
			y_coord = GetY_panel();

			// Si on a appuy sur la croix on revient au menu principal
			if ((x_coord > 110) && (y_coord < 15))
			{
				GLCD_PUTSTRING("X", 122, 0, 1);				// on inverse la couleur
				DelayMs(100);

//				* Configuration du timer 0 	en valeur d'interruptions toutes les 1ms
//				T0CS = 0;		// Clock source pour le timer = Internal instruction cycle clock
//				T08BIT = 1;		// Timer sur 8 bits, on va compter jusqu' 255 et aprs on recommence
//				PSA = 0;		// Prescaler pour TMR0
//				PS2	= 0;		// Prescaler de 1 pour TMR0
//				PS1 = 0;		// Prescaler de 1 pour TMR0
//				PS0 = 1;		// Prescaler de 1 pour TMR0
//				TMR0IE = 0;		// Initialisation du timer  0	*/
				TMR0 = 255;		// priode de 1 us
				T0CON = 0xC0;	// Registre de configuration gnral
				iApplication = 0;
				gotoMenuInitial();							// on raffiche le menu de dpart
				return;
			}	
					
		}

		// acquisition de la valeur de l'adc du potentiomtre et mise en forme pour le timer
		adc_rd = ADC_Read(2);   
		fPWM_value  = TIMER_MIN - (adc_rd * TIMER_MAX)/1024.0;

		// on met  jour le curseur sur l'cran que si les valeur sont diffrentes
		// on a 17 positions de curseur diffrentes, on recalcule le x correspondant
		if ( fPWM_value != pwm_old)
		{
			GLCD_PUTSTRING("-----------------", 10, 4, 1);
			x_cursor = 8 + LARG_CHAR*(adc_rd * 17.0)/1024.0;
			GLCD_PUTSTRING("|", x_cursor, 4, 1);		// mise  jour du curseur
		}

		pwm_old = fPWM_value;				// sauvegarde pour la fois suivante
		

     }while (1);
}